import { NextMiddleware } from 'next/server';
import { CookieOptions } from '../types';
export interface withMiddlewareAuthOptions {
    /**
     * Path relative to the site root to redirect an
     * unauthenticated visitor.
     *
     * The original request route will be appended via
     * a `redirectedFrom` query parameter, ex: `?redirectedFrom=%2Fdashboard`
     */
    redirectTo?: string;
    cookieOptions?: CookieOptions;
    tokenRefreshMargin?: number;
}
export declare type withMiddlewareAuth = (options?: withMiddlewareAuthOptions) => NextMiddleware;
export declare const withMiddlewareAuth: withMiddlewareAuth;
//# sourceMappingURL=withMiddlewareAuth.d.ts.map