/// <reference types="node" />
import { IncomingMessage, ServerResponse } from 'http';
import type { NextApiRequest, NextApiResponse } from 'next';
import type { NextApiRequestCookies } from 'next/dist/server/api-utils';
import { RequestAdapter, ResponseAdapter } from './types';
declare type NextRequest = NextApiRequest | (IncomingMessage & {
    cookies: NextApiRequestCookies;
});
export declare class NextRequestAdapter implements RequestAdapter {
    private req;
    constructor(request: NextRequest);
    setRequestCookie(name: string, value: string): void;
    getHeader(name: string): string | string[] | undefined;
}
export declare class NextResponseAdapter implements ResponseAdapter {
    private res;
    constructor(response: NextApiResponse | ServerResponse);
    getHeader(name: string): string | number | string[] | undefined;
    setHeader(name: string, value: string): this;
}
export {};
//# sourceMappingURL=NextAdapter.d.ts.map