import { RequestAdapter, ResponseAdapter } from '../adapters/types';
declare type Cookie = {
    name: string;
    value: string;
    maxAge: number;
    domain?: string;
    path?: string;
    sameSite?: string;
};
/**
 * Get Cookie Header strings.
 */
export declare function getCookieString(req: RequestAdapter, res: ResponseAdapter, cookies: Array<Cookie>): string[];
/**
 * Set one or more cookies.
 */
export declare function setCookies(req: RequestAdapter, res: ResponseAdapter, cookies: Array<Cookie>): void;
/**
 * Set one or more cookies.
 */
export declare function setCookie(req: RequestAdapter, res: ResponseAdapter, cookie: Cookie): void;
export declare function deleteCookie(req: RequestAdapter, res: ResponseAdapter, name: string): void;
export {};
//# sourceMappingURL=cookies.d.ts.map